#include <iostream>
#define int long long
using namespace std;
const int maxn = 1e4+10, max_shots = 2e2+10, maxm = 2e1 + 10, inf = 1e18;
int dp[maxn][max_shots], a[maxm], n, m;
bool bl[maxn][max_shots];

int f(int sum, int shots) {
    if (sum > n) return -inf;
    if (sum == n) return (shots > 0 ? 0 : -inf);
    if (bl[sum][shots]) return dp[sum][shots];
    bl[sum][shots] = 1; dp[sum][shots] = -inf;
    int ix = 0;
    for (int i = 1 ; i <= m ; ++i) {
        int res = f((shots+1) * a[i] + sum, shots+1);
        if (res == -inf) continue;
        res += a[i];
        if (res > dp[sum][shots]) {
            ix = i;
            dp[sum][shots] = res;
        }  
    }

    //cout << "f: " << sum << ' ' << shots << " = " << dp[sum][shots] << ' ' << ix << '\n';

    return dp[sum][shots];
}

signed main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;

    for (int i = 1 ; i <= m ; ++i)
        cin >> a[i];
    
    int res = f(0, 0);
    if (res < 0) cout << "Impossible\n";
    else cout << res << '\n';
    
    return 0;
}