#include<bits/stdc++.h>
using namespace std;
const int maxn = 2e6 + 10;
const int inf = 2e9 + 10;
const int LOG = 24;

int n, ar[maxn], br[maxn], m, dpa[maxn], dpb[maxn], d[maxn], dp[maxn][LOG], lg[maxn], pw[maxn], en[maxn];

void build_sparse_table()
{
    lg[0] = 0;
    for (int i = 1; i <= n; i ++)
        lg[i] = lg[i / 2] + 1;
    for (int i = 0; i <= 23; i ++)
        pw[i] = (1 << i);
    int to = lg[n];

    for (int i = 1; i <= n; i ++)
        dp[i][0] = d[i];

    for (int j = 1; j < to; j ++)
    {
        int offset = pw[j];
        for (int i = 1; i <= n - offset + 1; i ++)
        {
            dp[i][j] = min(dp[i][j - 1], dp[i + offset / 2][j - 1]);
        }
    }
/*for (int j = 0; j < to; j ++, cout << endl)
    for (int i = 1; i <= n; i ++)

        cout << dp[i][j] << " ";*/

}

int query(int l, int r)
{
    /**for (int i = 1; i <= n; i ++)
        cout << d[i] << " ";
    cout << endl;*/

    int dis = (r - l + 1), to = lg[dis] - 1;

    /*cout << dp[l][to] << endl;
    cout << l << " " << r << " " << to << endl;*/
    return min(dp[l][to], dp[r - pw[to] + 1][to]);
}

void init(int M, std::vector < int > a, std::vector < int > b)
{
    n = a.size();
    m = M;
    for (int i = 1; i <= n; i ++)
        ar[i] = a[i - 1], dpa[i] = dpa[i - 1] + a[i - 1];
    for (int i = 1; i < n; i ++)
        br[i] = b[i - 1], dpb[i] = dpb[i - 1] + b[i - 1];

    int i = n, j = n;
    while(i > 0)
    {
        while(dpa[j] - dpa[i - 1] >= m)
            j --;
        if (j == n)
            d[i] = inf, en[i] = n + 1;
        else
            j ++, d[i] = dpb[j - 1] - dpb[i - 1], en[i] = j;
        i --;
    }

    build_sparse_table();
}

int message(int k)
{
    int l = 1, r = n;
    while(l <= r)
    {
        int mid = (l + r) / 2;
        if (en[mid] >= k)
            r = mid - 1;
        else
            l = mid + 1;
    }

    return query(l, k);

    /**int t = m, ans = 2e9;
    for (int i = k; i > 0; i --)
    {
        t -= ar[i];
        if (t <= 0)
        {
            int dis = dpb[k - 1] - dpb[i - 1];
            ans = min(ans, dis);
            break;
        }
        if (t - (dpa[n] - dpa[k]) > 0)
            continue;

        int dis = to[i];
        ans = min(ans, dis);
    }
    return ans;*/
}
