#include<bits/stdc++.h>
using namespace std;

struct idx
{
    int id;
    idx() {}
    idx(int a)
    {
        id=a;
    }
};

int su[2000006];
int ans[2000006];
int dv[3][2000006];

bool operator<(idx p, idx q)
{
    return dv[2][p.id]<dv[2][q.id];
}

bool operator==(idx p, idx q)
{
    return dv[2][p.id]==dv[2][q.id];
}

int tree[8000006];

void init_tree(int v, int le, int ri)
{
    if(le==ri) tree[v]=ans[le];
    else
    {
        int mid=(le+ri)/2;
        init_tree(2*v, le, mid);
        init_tree(2*v+1, mid+1, ri);
        tree[v]=2000000001;
    }
}

void update(int v, int le, int ri, int be, int en, int st)
{
    if(le>en || ri<be) return;
    if(be<=le && ri<=en) tree[v]=min(st, tree[v]);
    else
    {
        int mid=(le+ri)/2;
        update(2*v, le, mid, be, en, st);
        update(2*v+1, mid+1, ri, be, en, st);
    }
}

int query(int v, int le, int ri, int id)
{
    if(le>id || ri<id) return 2000000001;
    if(le==ri) return tree[v];
    int mid=(le+ri)/2;
    if(id<=mid) return min(tree[v], query(2*v, le, mid, id));
    else return min(tree[v], query(2*v+1, mid+1, ri, id));
}

void init(int M, vector <int> a, vector<int> b)
{
    int n=a.size(), tsu=a[0], tRi=0, br=0;
    su[0]=0;
    for(int i=1; i<n; i++) su[i]=su[i-1]+b[i-1];
    for(int i=0; i<n; i++, br++)
    {
        while(tsu<M && tRi<n-1)
        {
            tRi++;
            tsu+=a[tRi];
        }
        if(tRi==n-1 && tsu<M) break;
        dv[0][i]=i;
        dv[1][i]=tRi;
        dv[2][i]=su[tRi]-su[i];
        tsu-=a[i];

    }
    for(int i=0; i<n; i++) ans[i]=2000000000;
    int idint=br-1;
    for(int i=n-1; i>=0; i--)
    {
        while(idint>=0 && dv[1][idint]>=i) idint--;
        if(idint==-1) break;
        ans[i]=su[i]-su[dv[0][idint]];
    }
    init_tree(1, 0, n);
    for(int i=0; i<br; i++) update(1, 0, n, dv[0][i], dv[1][i], dv[2][i]);
    for(int i=0; i<n; i++) ans[i]=query(1, 0, n, i);
}

int message(int k)
{
    return ans[k-1];
}
