#include <iostream>
#include <algorithm>
#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
#define int long long
using namespace std;
const int buff_size = 2e5+10;

char buff[buff_size];
int buff_ix = buff_size-1;

void read_char() {
    if (++buff_ix == buff_size) fread(buff, buff_size, 1, stdin), buff_ix = 0;
}

void read_int(int &ret) {
    ret = 0;
    for (; buff[buff_ix] < '0' || '9' < buff[buff_ix]; read_char());
    for (; '0' <= buff[buff_ix] && buff[buff_ix] <= '9'; read_char())
        ret = 10*ret + buff[buff_ix] - '0';
}
int t, n;
int divisors[20], len;

void find_divisors() {
    for (int i = 2 ; i*i <= n ; i += 2) {
        if (n % i == 0) divisors[len++] = i;
        while (n % i == 0) n /= i;
        if (i == 2) i = 1;
    }

    if (n > 1) divisors[len++] = n;
}

int ans[2];

void f(bool bl, int to, int ix, int del_cnt, int lcm) {
    //cout << "f: " << bl << ' ' << to << ' ' << ix << ' ' << del_cnt << ' ' << lcm << ' ' << divisors.size() << '\n';
    if (lcm > to) return;
    if (ix == len) {
        if (lcm == 0) return;
        if (del_cnt % 2 == 0) ans[bl] -= (to / lcm);
        else ans[bl] += (to/lcm);
        //cout << "return?\n";
        return;
    }
    //cout << "not add\n";
    f(bl, to, ix+1, del_cnt, lcm);
    //cout << "ended not adding\n";
    if (lcm > 0) {
        int curr = divisors[ix]/__gcd(lcm, divisors[ix]);
        //cout << "curr: " << curr << ' ' << to << ' ' << lcm << ' ' << to/lcm << '\n';
        if (curr > to/lcm) return;
    }
    //cout << "add divisor: \n";
    f(bl, to, ix+1, del_cnt+1, (lcm == 0 ? divisors[ix] : lcm*divisors[ix]/__gcd(lcm, divisors[ix])));
}

int l, r;

signed main () {
    ios_base :: sync_with_stdio(0);
    cout.tie(nullptr);
    read_int(n); read_int(t);
    find_divisors();

    /*cout << "divisors: ";
    for (int i : divisors) cout << i << ' ';
    cout << '\n';*/

    while (t--) {
        ans[0] = ans[1] = 0;
        read_int(l); read_int(r);
        f(0, l-1, 0, 0, 0);
        //cout << "call: " << r << '\n';
        f(1, r, 0, 0, 0);     
        cout << (r-l+1) - (ans[1] - ans[0]) << '\n';   
    }
    
    return 0;
}