#include <bits/stdc++.h>>
using namespace std;

const long long maxn = 2*(1e6+1);
long long pl[maxn], pp[maxn], ll, nn;

void init(long long M, std::vector <long long> a, std::vector <long long> b)
{
    ll = M;
    long long len1 = a.size(), i;
    nn = len1;
    for(i=1; i<len1; ++i)
    {
        pl[i] = pl[i-1]+a[i-1];
        pp[i+1] = pp[i]+b[i-1];
    }
    pl[len1] = pl[len1-1]+a[len1-1];
}

long long bin_search_left(long long listi, long long k)
{
    long long l = 1, r = k, ans = 0;
    long long mid = (l+r)/2;
    while(l <= r)
    {
        if(pl[k]-pl[mid-1] >= listi)
        {
            ans = mid;
            l = mid+1;
        }
        else r = mid-1;
        mid = (l+r)/2;
    }
    return ans;
}

long long bin_search_right(long long listi, long long k)
{
    long long l = k, r = nn, ans = nn+1;
    long long mid = (l+r)/2;
    while(l <= r)
    {
        if(pl[mid]-pl[k-1] >= listi)
        {
            ans = mid;
            r = mid-1;
        }
        else l = mid+1;
        mid = (l+r)/2;
    }
    return ans;
}

int message(long long k)
{
    long long l1 = bin_search_left(ll,k), ans;
    long long r1 = bin_search_right(ll,k), ans2;
    if(l1 > 0) ans = pp[k]-pp[l1];
    if(r1 <= nn)
    {
        ans2 = pp[r1]-pp[k];
        if(ans2 > ans) ans = ans2;
    }
    if(l1 <= 0  &&  r1 > nn) ans = -1;
    long long i, r;
    for(i=l1+1; i<k; ++i)
    {
        r = bin_search_right(ll-(pl[k]-pl[i-1]), k+1);
        if(r <= nn)
        {
            ans2 = pp[r]-pp[i];
            if(ans == -1  ||  ans2 < ans) ans = ans2;
        }
    }
    return (int)(ans);
}